//+------------------------------------------------------------------+

//| Wick.mq4 |

//| Seavo |

//| http://www.forexfactory.com/member.php?u=17692 |

//+------------------------------------------------------------------+

#property copyright "Seavo"
#property link "http://www.forexfactory.com/member.php?u=17692"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 White
#property indicator_color4 White

//---- external variables
extern bool   ShowAtr          = true;
extern int    AtrPeriod        = 14;
extern double kAtr             = 0.62;
extern bool   ShowNetWick      = true;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";


//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];
//+------------------------------------------------------------------+

//| Custom indicator initialization function |

//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,trend);
   if (ShowAtr)
   {
     SetIndexStyle(2,DRAW_LINE);
     SetIndexStyle(3,DRAW_LINE);
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }

   IndicatorShortName("Wick"); 
   return(0);
}

//+------------------------------------------------------------------+

//| Custor indicator deinitialization function |

//+------------------------------------------------------------------+

int deinit() { return(0); }

//+------------------------------------------------------------------+

//| Custom indicator iteration function |

//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   

   //
   //
   //
   //
   //
   
   for (pos=limit; pos >= 0; pos--)
   {                    
     if (iOpen(NULL,0,pos) > iClose(NULL,0,pos))
     {
        double dResult1 = iHigh(NULL,0,pos) - iOpen(NULL,0,pos);
     }
     if (iOpen(NULL,0,pos) <= iClose(NULL,0,pos))
     {
        dResult1 = iHigh(NULL,0,pos) - iClose(NULL,0,pos);
     }
     if (iOpen(NULL,0,pos) > iClose(NULL,0,pos))
     {
        double dResult2 = iLow(NULL,0,pos) - iClose(NULL,0,pos);
     }
     if (iOpen(NULL,0,pos) <= iClose(NULL,0,pos))
     {
        dResult2 = iLow(NULL,0,pos) - iOpen(NULL,0,pos);
     }
     if (ShowNetWick)
     {
       double dResultNet = dResult1+dResult2;
       if (dResultNet>0) {  ExtMapBuffer1[pos] = dResultNet ; }
       else                 ExtMapBuffer2[pos] = dResultNet ; }
       else              {  ExtMapBuffer1[pos] = dResult1 ; ExtMapBuffer2[pos] = dResult2 ;}
     
       ExtMapBuffer3[pos] = iATR(NULL,0,AtrPeriod, pos)     *kAtr ;
       ExtMapBuffer4[pos] = (0 - iATR(NULL,0,AtrPeriod, pos)*kAtr); 
       trend[pos] = trend[pos+1];
          if (ExtMapBuffer1[pos]>ExtMapBuffer3[pos]) trend[pos] =-1;
          if (ExtMapBuffer2[pos]<ExtMapBuffer4[pos]) trend[pos] = 1;
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," wick0.3 ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," wick0.3 "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," wick0.3 " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
      }
}
      